
; Die Funktionen zum erstellen von Bitmaps.
; KEINE Verarbeitung oder Bearbeitung von Bitmaps.

#include-once
#include <GDIPlus.au3>

Global $___IMAGEUDF_DLL_GDI32

#region - Image - Kern

Func _Image_Startup()
	$___IMAGEUDF_DLL_GDI32 = DllOpen('Gdi32.dll')
EndFunc

Func _Image_Shutdown()
	DllClose($___IMAGEUDF_DLL_GDI32)
EndFunc

; #FUNCTION# ;===============================================================================
; Name...........: _Image_Create
; Description ...: Creates an empty Image
; Syntax.........: _Image_Create($iW, $iH)
; Parameters ....: $iW		- Width of the image
;                  $iH		- Height of the image
; Return values .: Dllstruct containing the image informations
; Author ........: Mars
; Modified.......:
; Remarks .......:
; Related .......: _Image_CreateFromFile, _Image_Delete
; Link ..........:
; Example .......:
; ===========================================================================================
Func _Image_Create($iW, $iH)
	Local $Ptr, $hDC, $hBmp, $tBMI, $aDIB, $vStruct
	$hDC = _WinAPI_CreateCompatibleDC(0)
	$tBMI = DllStructCreate('struct;dword Size;long Width;long Height;word Planes;word BitCount;dword Compression;dword SizeImage;long XPelsPerMeter;long YPelsPerMeter;dword ClrUsed;dword ClrImportant;endstruct;dword RGBQuad')
	DllStructSetData($tBMI, 'Size', DllStructGetSize($tBMI) - 4)
	DllStructSetData($tBMI, 'Width', $iW)
	DllStructSetData($tBMI, 'Height', -$iH)
	DllStructSetData($tBMI, 'Planes', 1)
	DllStructSetData($tBMI, 'BitCount', 32)
	$aDIB = DllCall($___IMAGEUDF_DLL_GDI32, 'ptr', 'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 0, 'ptr*', 0, 'ptr', 0, 'uint', 0)
	$hBmp = $aDIB[0]
	$Ptr = $aDIB[4]
	_WinAPI_SelectObject($hDC, $hBmp)
	$vStruct = DllStructCreate('int[5]')
	DllStructSetData($vStruct, 1, $hDC, 1)
	DllStructSetData($vStruct, 1, $iW, 2)
	DllStructSetData($vStruct, 1, $iH, 3)
	DllStructSetData($vStruct, 1, $Ptr, 4)
	DllStructSetData($vStruct, 1, $hBmp, 5)
	Return $vStruct
EndFunc   ;==>_Image_Create

; #FUNCTION# ;===============================================================================
; Name...........: _Image_CreateFromFile
; Description ...: Creates an Image from file
; Syntax.........: _Image_CreateFromFile($sPath)
; Parameters ....: $sPath	- Path to image file
; Return values .: Dllstruct containing the image informations
; Author ........: Mars
; Modified.......:
; Remarks .......:
; Related .......: _Image_Create, _Image_Delete
; Link ..........:
; Example .......:
; ===========================================================================================
Func _Image_CreateFromFile($sPath)
	Local $hImage = _GDIPlus_ImageLoadFromFile($sPath)
	Local $iW = _GDIPlus_ImageGetWidth($hImage)
	Local $iH = _GDIPlus_ImageGetHeight($hImage)
	Local $vImage = _Image_Create($iW, $iH)
	Local $hGraphic = _GDIPlus_GraphicsCreateFromHDC(DllStructGetData($vImage, 1, 1))
	_GDIPlus_GraphicsDrawImage($hGraphic, $hImage, 0, 0)
	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_GraphicsDispose($hGraphic)
	Return $vImage
EndFunc   ;==>_Image_CreateFromFile

; #FUNCTION# ;===============================================================================
; Name...........: _Image_Delete
; Description ...: Deletes an Image
; Syntax.........: _Image_Delete(ByRef $vStruct)
; Parameters ....: $vStruct	- DllStruct returned by an Image_Create function
; Return values .: None
; Author ........: Mars
; Modified.......:
; Remarks .......:
; Related .......: _Image_Create, _Image_CreateFromFile
; Link ..........:
; Example .......:
; ===========================================================================================
Func _Image_Delete(ByRef $vStruct)
	_WinAPI_DeleteObject(DllStructGetData($vStruct, 1, 5))
	_WinAPI_DeleteDC(DllStructGetData($vStruct, 1, 1))
	$vStruct = 0
EndFunc   ;==>_Image_Delete

#endregion - Image - Kern
;endregion - Image - Kern